using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace Frief
{

    public class BDSMSeat : MVRScript
    {
        #region PluginInfo    
        public string pluginAuthor = "Frief";
        public string pluginName = "BDSM-Pillar";
        public string pluginVersion = "1";
        public string pluginDate = "15/08" + "/2021";
        public string pluginDescription = @"Used";
        #endregion

        #region Vars    

        public JSONStorableBool SawEnabled;

        public GameObject player;
        public GameObject Ks_Fridge;

        protected JSONStorableFloat ScrubA;
        protected JSONStorableFloat ScrubB;

        private float previousValue1;
        private float previousValue2;
        private float previousValue3;

        private float maxY;
        private float minY;
        private float ScrubB_maxY;
        private float ScrubB_minY;

        private float midY;


        private string objectNameSearchString = "Pillar";
        public Transform ObjectRoot;
        public Transform BDSMPillar_seat;
        public Transform BDSMPillar_Ancorpoint;
        public GameObject BDSMPillar_saw;


        private Renderer BDSMPillar_seatRenderer;


        private bool editorInitialized = false;
        private int initLoops = 0;
        private int maxInitLoops = 360; //3600 for one minute

        private static Atom currentAtom;
        private static string currentAtomName = "None";
        private static string tempAtomName = "None";

        #endregion

        public override void Init()
        {
            try
            {
                if (containingAtom.type != "CustomUnityAsset")
                {
                    SuperController.LogError("BDSM-Saddle: This CUA could not be initialized properly.Please select a compatible object and reload the script.");
                    return;
                }


                //**************  ScrubA
                maxY = 1.586257f;
                minY = 0.3456210f;

                ScrubA = new JSONStorableFloat("Sattle Hight", 0, -0.1561669f, 0.3073476f, true);
                RegisterFloat(ScrubA);
                CreateSlider(ScrubA, false);

                //**************  ScrubB
                ScrubB_maxY = 2.039427f;
                ScrubB_minY = 1.115366f;

                ScrubB = new JSONStorableFloat("Attachment Hight", 0, 0.9985201f, 2.056002f, true);
                RegisterFloat(ScrubB);
                CreateSlider(ScrubB, false);

                SawEnabled = new JSONStorableBool("Show the Saw", true); RegisterBool(SawEnabled); CreateToggle((SawEnabled), false);

                // A tiny bit of help to give some info to your fellow creator and/or player
                JSONStorableString helpText = new JSONStorableString("Help",
                    "<color=#000><size=35><b>Help</b></size></color>\n\n" +
                    "<color=#333>" +
                    "Simple script to allow you to set the hight for for the BDSM-Sattle .\n\n" +
                    "Youn can find it under https://hub.virtamate.com/members/frief.1649 \n\n" +
                    "</color>");
                UIDynamic helpTextfield = CreateTextField(helpText, true);
                helpTextfield.height = 1100.0f;

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        // Update is called with each rendered frame by Unity
        void Update()
        
        {

        

        var Slider1 = ScrubA.val;
            var Slider2 = ScrubB.val;

            if (initLoops < maxInitLoops && editorInitialized == false)
            {
                initLoops++;
                InitEditor();
            }
            if (initLoops == maxInitLoops)
            {
                //SuperController.LogError("BDSMSaddle : This CUA could not be initialized properly. Please select a compatible object and reload the script.");
                initLoops++; // To avoid spamming the log with the error
            }

            if (SawEnabled.val)
            {
             BDSMPillar_saw.SetActive(true);
            }
            else
            {
              BDSMPillar_saw.SetActive(false);
            }


            if (previousValue1 != Slider1)
            {
            OnSlider1Changed();
            }

            if (previousValue2 != Slider2)
            {
                
                OnSlider2Changed();
            }
        }

        private bool InitEditor()
        {
            if (editorInitialized == true) return true;

            ObjectRoot = getObjectRoot(containingAtom.reParentObject);
            if (ObjectRoot == null)
            {
                return false;
            }

            BDSMPillar_seat = ObjectRoot.Find("SeatPivot");
            BDSMPillar_Ancorpoint= ObjectRoot.Find("HoldingPivit");
            BDSMPillar_saw = GameObject.Find("Pillar/SeatPivot/saw");

                     return false;
        }

        private Transform getObjectRoot(Transform parent)
        {
            foreach (Transform child in parent)
            {
                if (child.name.Contains(objectNameSearchString))
                {
                    return child;
                }
                else
                {
                    Transform childSearch = getObjectRoot(child);
                    if (childSearch != null) return childSearch;
                }
            }

            return null;
        }

        void OnSlider2Changed()
        {
            Slider2Changed();
        }

        void OnSlider1Changed()
        {
            Slider1Changed();
        }

        void Slider1Changed()
        {
            var Slider1 = ScrubA.val;
            var a = Slider1 - previousValue1;

            if (BDSMPillar_seat.transform.position.y < minY)
            {
                var BDSMPillar_seatX = BDSMPillar_seat.transform.position.x;
                var BDSMPillar_seatZ = BDSMPillar_seat.transform.position.z;

                BDSMPillar_seat.transform.position = new Vector3(BDSMPillar_seatX, minY, BDSMPillar_seatZ);
                previousValue1 = ScrubA.val;

            }
            else
            {
                BDSMPillar_seat.transform.Translate(0, a, 0, Space.Self);
                previousValue1 = ScrubA.val;
            }


            if (BDSMPillar_seat.transform.position.y > maxY)

            {
                var BDSMPillar_seatX = BDSMPillar_seat.transform.position.x;
                var BDSMPillar_seatZ = BDSMPillar_seat.transform.position.z;

                BDSMPillar_seat.transform.position = new Vector3(BDSMPillar_seatX, maxY, BDSMPillar_seatZ);
                previousValue1 = ScrubA.val;
            }
            else
            {
                BDSMPillar_seat.transform.Translate(0, a, 0, Space.Self);
                previousValue1 = ScrubA.val;
            }

            BDSMPillar_seat.transform.Translate(0, a, 0, Space.Self);
            previousValue1 = ScrubA.val;
            
        }

        void Slider2Changed()
        {
            var Slider2 = ScrubB.val;
            var a = Slider2 - previousValue2;

           SuperController.LogError("ancor" + Slider2);

            if (BDSMPillar_Ancorpoint.transform.position.y < ScrubB_minY)
            {
                var BDSMPillar_AncorpointX = BDSMPillar_Ancorpoint.transform.position.x;
                var BDSMPillar_AncorpointZ = BDSMPillar_Ancorpoint.transform.position.z;

                BDSMPillar_Ancorpoint.transform.position = new Vector3(BDSMPillar_AncorpointX, ScrubB_minY, BDSMPillar_AncorpointZ);
                previousValue2 = ScrubB.val;
                
            }
            else
            {
                BDSMPillar_Ancorpoint.transform.Translate(0, a, 0, Space.Self);
                previousValue2 = ScrubB.val;
            }


            if (BDSMPillar_Ancorpoint.transform.position.y > ScrubB_maxY)

            {
                var BDSMPillar_AncorpointX = BDSMPillar_Ancorpoint.transform.position.x;
                var BDSMPillar_AncorpointZ = BDSMPillar_Ancorpoint.transform.position.z;

                BDSMPillar_Ancorpoint.transform.position = new Vector3(BDSMPillar_AncorpointX, ScrubB_maxY, BDSMPillar_AncorpointZ);
                previousValue2 = ScrubB.val; 
            }
            else
            {
               BDSMPillar_Ancorpoint.transform.Translate(0, a, 0, Space.Self);
               previousValue2 = ScrubB.val;
            }

            BDSMPillar_Ancorpoint.transform.Translate(0, a, 0, Space.Self);
            previousValue2 = ScrubB.val;

        }
    }
}